/*
* Jalview - A Sequence Alignment Editor and Viewer
* Copyright (C) 2005 AM Waterhouse, J Procter, G Barton, M Clamp, S Searle
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
*/
package MCview;

import java.awt.*;

import java.util.*;


public class Atom {
    double x;
    double y;
    double z;
    int number;
    String name;
    String resName;
    int resNumber;
    int type;
    Color color;
    String chain;

    public Atom(StringTokenizer str) {
        this.number = (new Integer(str.nextToken())).intValue();
        this.name = str.nextToken();
        this.resName = str.nextToken();

        String tmpstr = new String();

        try {
            tmpstr = str.nextToken();

            this.resNumber = (new Integer(tmpstr).intValue());
            this.chain = "A";
            this.color = Color.green;
        } catch (NumberFormatException e) {
            this.chain = tmpstr;

            if (tmpstr.equals("A")) {
                this.color = new Color((float) Math.random(),
                        (float) Math.random(), (float) Math.random());
            } else {
                this.color = Color.red;
            }

            this.resNumber = (new Integer(str.nextToken()).intValue());
        }

        this.x = (double) (new Double(str.nextToken()).floatValue());
        this.y = (double) (new Double(str.nextToken()).floatValue());
        this.z = (double) (new Double(str.nextToken()).floatValue());
    }

    public void setColor(Color col) {
        this.color = col;
    }
}
