/*
 * Jalview - A Sequence Alignment Editor and Viewer
 * Copyright (C) 2005 AM Waterhouse, J Procter, G Barton, M Clamp, S Searle
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 */



package jalview.appletgui;

import java.awt.*;
import java.util.*;
import jalview.datamodel.*;

public class PaintRefresher
{
  static Hashtable components = new Hashtable();

  public static void Register(Component comp, AlignmentI al)
  {
    if(components.containsKey(al))
    {
      Vector comps = (Vector)components.get(al);
      comps.addElement(comp);
    }
    else
    {
      Vector vcoms = new Vector();
      vcoms.addElement(comp);
      components.put(al, vcoms);
    }
  }

  public static void Refresh(AlignmentI al)
  {
    Refresh(null, al);
  }

  public static void Refresh(Component c, AlignmentI al)
  {
    Component temp;
    Vector coms = (Vector)components.get(al);
    Enumeration e = coms.elements();
    while( e.hasMoreElements() )
    {
      temp = (Component)e.nextElement();

      if(!temp.isValid())
        coms.removeElement( temp );
      else if( temp == c )
        continue;

      temp.repaint();
    }

  }

}

