/*
 * Jalview - A Sequence Alignment Editor and Viewer
 * Copyright (C) 2005 AM Waterhouse, J Procter, G Barton, M Clamp, S Searle
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 */

package jalview.appletgui;

import java.util.*;

import java.awt.event.*;

import jalview.analysis.*;
import jalview.datamodel.*;
import jalview.jbappletgui.*;

public class PairwiseAlignPanel
    extends GPairwiseAlignPanel
{
  Vector sequences = new Vector();
  AlignViewport av;

  public PairwiseAlignPanel(AlignViewport av)
  {
    super();
    this.av = av;
    float scores[][] = new float[av.getAlignment().getHeight()][av.getAlignment().
        getHeight()];
    double totscore = 0;
    int count = av.getSelectionGroup().getSize();

    int acount = 0;
    for (int i = 1; i < count; i++)
    {
      for (int j = 0; j < i; j++)
      {
        acount++;
        AlignSeq as = new AlignSeq(av.getSelectionGroup().getSequenceAt(i),
                                   av.getSelectionGroup().getSequenceAt(j),
                                   "pep");

        as.calcScoreMatrix();
        as.traceAlignment();
        as.printAlignment();
        scores[i][j] = (float) as.getMaxScore() / (float) as.getASeq1().length;
        totscore = totscore + scores[i][j];

        textarea.append(as.getOutput());
        sequences.addElement(new Sequence(as.getS1().getName(), as.getAStr1()));
        sequences.addElement(new Sequence(as.getS2().getName(), as.getAStr2()));

      }
    }

    if (count > 2)
    {
      for (int i = 0; i < count; i++)
      {
        for (int j = 0; j < i; j++)
        {
          jalview.util.Format.print(System.out, "%7.3f",
                                    scores[i][j] / totscore);
        }
      }
    }
  }

  protected void viewInEditorButton_actionPerformed(ActionEvent e)
  {

    Sequence[] seq = new Sequence[sequences.size()];

    for (int i = 0; i < sequences.size(); i++)
    {
      seq[i] = (Sequence) sequences.elementAt(i);
    }

    AlignFrame af = new AlignFrame(new Alignment(seq));
    jalview.bin.JalviewLite.addFrame(af, "Pairwise Aligned Sequences",
                                     AlignFrame.NEW_WINDOW_WIDTH,
                                     AlignFrame.NEW_WINDOW_HEIGHT);

  }

}
