/*
 * Jalview - A Sequence Alignment Editor and Viewer
 * Copyright (C) 2005 AM Waterhouse, J Procter, G Barton, M Clamp, S Searle
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 */
package jalview.datamodel;

/**
 * DOCUMENT ME!
 *
 * @author $author$
 * @version $Revision: 1.7 $
 */
public class SequenceFeature
{
    int begin;
    int end;
    String type;
    String description;
    String status;

    /**
     * Creates a new SequenceFeature object.
     */
    public SequenceFeature()
    {
    }

    /**
     * Creates a new SequenceFeature object.
     *
     * @param type DOCUMENT ME!
     * @param start DOCUMENT ME!
     * @param end DOCUMENT ME!
     * @param description DOCUMENT ME!
     * @param status DOCUMENT ME!
     */
    public SequenceFeature(String type, int start, int end, String description,
        String status)
    {
        this.type = type;
        this.begin = start;
        this.end = end;
        this.description = description;
        this.status = status;
    }

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public int getStart()
    {
        return begin;
    }

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public int getEnd()
    {
        return end;
    }

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public String getType()
    {
        return type;
    }

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public String getDescription()
    {
        return description;
    }

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public String getStatus()
    {
        return status;
    }

    /*
          <xs:enumeration value="active site" />
         <xs:enumeration value="binding site" />
         <xs:enumeration value="calcium-binding region" />
         <xs:enumeration value="chain" />
         <xs:enumeration value="cross-link" />
         <xs:enumeration value="disulfide bond" />
         <xs:enumeration value="DNA-binding region" />
         <xs:enumeration value="domain" />
         <xs:enumeration value="glycosylation site" />
         <xs:enumeration value="helix" />
         <xs:enumeration value="initiator methionine" />
         <xs:enumeration value="lipid moiety-binding region" />
         <xs:enumeration value="metal ion-binding site" />
         <xs:enumeration value="modified residue" />
         <xs:enumeration value="mutagenesis site" />
         <xs:enumeration value="non-consecutive residues" />
         <xs:enumeration value="non-terminal residue" />
         <xs:enumeration value="nucleotide phosphate-binding region" />
         <xs:enumeration value="peptide" />
         <xs:enumeration value="propeptide" />
         <xs:enumeration value="repeat" />
         <xs:enumeration value="selenocysteine" />
         <xs:enumeration value="sequence conflict" />
         <xs:enumeration value="sequence variant" />
         <xs:enumeration value="signal peptide" />
         <xs:enumeration value="similar" />
         <xs:enumeration value="site" />
         <xs:enumeration value="splice variant" />
         <xs:enumeration value="strand" />
         <xs:enumeration value="thioether bond" />
         <xs:enumeration value="thiolester bond" />
         <xs:enumeration value="transit peptide" />
         <xs:enumeration value="transmembrane region" />
         <xs:enumeration value="turn" />
         <xs:enumeration value="unsure residue" />
         <xs:enumeration value="zinc finger region" />
     */
}
