/*
* Jalview - A Sequence Alignment Editor and Viewer
* Copyright (C) 2005 AM Waterhouse, J Procter, G Barton, M Clamp, S Searle
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
*/
package jalview.jbappletgui;

import java.awt.*;
import java.awt.event.*;


public class GTreePanel extends Frame {
    BorderLayout borderLayout1 = new BorderLayout();
    protected ScrollPane scrollPane = new ScrollPane();
    MenuBar jMenuBar1 = new MenuBar();
    Menu jMenu2 = new Menu();
    protected MenuItem fontSize = new MenuItem();
    protected CheckboxMenuItem bootstrapMenu = new CheckboxMenuItem();
    protected CheckboxMenuItem distanceMenu = new CheckboxMenuItem();
    protected CheckboxMenuItem placeholdersMenu = new CheckboxMenuItem();
    protected CheckboxMenuItem fitToWindow = new CheckboxMenuItem();
    Menu fileMenu = new Menu();
    MenuItem newickOutput = new MenuItem();

    public GTreePanel() {
        try {
            jbInit();
            this.setMenuBar(jMenuBar1);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private void jbInit() throws Exception {
        setLayout(borderLayout1);
        this.setBackground(Color.white);
        this.setFont(new java.awt.Font("Verdana", 0, 12));
        jMenu2.setLabel("View");
        fontSize.setLabel("Font Size - 12");
        fontSize.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    fontSize_actionPerformed(e);
                }
            });
        bootstrapMenu.setLabel("Show Bootstrap Values");
        bootstrapMenu.addItemListener(new java.awt.event.ItemListener() {
                public void itemStateChanged(ItemEvent e) {
                    bootstrapMenu_actionPerformed(null);
                }
            });
        distanceMenu.setLabel("Show Distances");
        distanceMenu.addItemListener(new java.awt.event.ItemListener() {
                public void itemStateChanged(ItemEvent e) {
                    distanceMenu_actionPerformed(null);
                }
            });
        placeholdersMenu.setLabel("Mark Unassociated Leaves");
        placeholdersMenu.addItemListener(new java.awt.event.ItemListener() {
                public void itemStateChanged(ItemEvent e) {
                    placeholdersMenu_actionPerformed(null);
                }
            });
        fitToWindow.setState(true);
        fitToWindow.setLabel("Fit To Window");
        fitToWindow.addItemListener(new java.awt.event.ItemListener() {
                public void itemStateChanged(ItemEvent e) {
                    fitToWindow_actionPerformed(null);
                }
            });
        fileMenu.setLabel("File");
        newickOutput.setLabel("Newick Format");
        newickOutput.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent actionEvent) {
                    newickOutput_actionPerformed(actionEvent);
                }
            });
        add(scrollPane, BorderLayout.CENTER);
        jMenuBar1.add(fileMenu);
        jMenuBar1.add(jMenu2);
        jMenu2.add(fitToWindow);
        jMenu2.add(fontSize);
        jMenu2.add(distanceMenu);
        jMenu2.add(bootstrapMenu);
        jMenu2.add(placeholdersMenu);
        fileMenu.add(newickOutput);
    }

    protected void printMenu_actionPerformed(ActionEvent e) {
    }

    protected void fontSize_actionPerformed(ActionEvent e) {
    }

    protected void distanceMenu_actionPerformed(ActionEvent e) {
    }

    protected void bootstrapMenu_actionPerformed(ActionEvent e) {
    }

    protected void placeholdersMenu_actionPerformed(ActionEvent e) {
    }

    protected void fitToWindow_actionPerformed(ActionEvent e) {
    }

    public void newickOutput_actionPerformed(ActionEvent actionEvent) {
    }
}
