/*
 * Jalview - A Sequence Alignment Editor and Viewer
 * Copyright (C) 2005 AM Waterhouse, J Procter, G Barton, M Clamp, S Searle
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 */
package jalview.schemes;

import java.awt.*;

public class UserColourScheme
    extends ResidueColourScheme
{
  protected String schemeName;

  public UserColourScheme(String colour)
  {
    Color col = null;
    try{
      int value = Integer.parseInt(colour, 16);
      col = new Color(value);
    }
    catch(NumberFormatException ex){}

    if(col==null)
      col = ColourSchemeProperty.getAWTColorFromName(colour);

    if(col==null)
    {
      System.out.println("Unknown colour!! "+colour);
    }

    colors = new Color[24];
    for(int i=0; i<24; i++)
      colors[i] = col;
  }

  public UserColourScheme(Color[] newColors)
  {
    colors = newColors;
  }

  public Color[] getColours()
  {
    return colors;
  }

  public void setName(String name)
  {
    schemeName = name;
  }
  public String getName()
  {
    return schemeName;
  }
}
